-- =============================================================================================================
-- *
-- * Copyright (c) M.Freeman
-- *
-- * File Name: mux_2.vhd
-- *
-- * Version: V1.0
-- *
-- * Release Date: 
-- *
-- * Author(s): M.Freeman
-- *
-- * Description: Generic two input multiplexer
-- *
-- * Change History:  $Author: $
-- *                  $Date: $
-- *                  $Revision: $
-- *
-- * Conditions of Use: THIS CODE IS COPYRIGHT AND IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND, INCLUDING,
-- *                    BUT NOT LIMITED TO, ANY IMPLIED WARRANTY OF MERCHANTABILITY AND FITNESS FOR A
-- *                    PARTICULAR PURPOSE.
-- *
-- * Notes:
-- *  
-- =============================================================================================================

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY mux_2 IS
GENERIC (
  width : INTEGER := 32 );
PORT ( 
  din_a : IN STD_LOGIC_VECTOR(width-1 DOWNTO 0);
  din_b : IN STD_LOGIC_VECTOR(width-1 DOWNTO 0);  
  dout : OUT STD_LOGIC_VECTOR(width-1 DOWNTO 0);
  sel : IN STD_LOGIC );
END mux_2;

ARCHITECTURE mux_2_arch OF mux_2 IS
 
BEGIN

  mux : PROCESS(sel, din_a, din_b)
  BEGIN
    IF sel = '0'
    THEN
      dout <= din_a;
    ELSE
      dout <= din_b;
    END IF;
  END PROCESS;  

END mux_2_arch;
