-- =============================================================================================================
-- *
-- * Copyright (c) M.Freeman
-- *
-- * File Name: wide_nor_gate.vhd
-- *
-- * Version: V1.0
-- *
-- * Release Date:
-- *
-- * Author(s): M.Freeman
-- *
-- * Description: Multiple input NOR gate
-- *
-- * Change History:  $Author: $
-- *                  $Date: $
-- *                  $Revision: $
-- *
-- * Conditions of Use: THIS CODE IS COPYRIGHT AND IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND, INCLUDING,
-- *                    BUT NOT LIMITED TO, ANY IMPLIED WARRANTY OF MERCHANTABILITY AND FITNESS FOR A
-- *                    PARTICULAR PURPOSE.
-- *
-- * Notes: 
-- *
-- =============================================================================================================

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;

--LIBRARY UNISIM;
--USE UNISIM.VCOMPONENTS.ALL;

ENTITY wide_nor_gate IS
GENERIC (
  WIDTH : INTEGER := 7 );
PORT (
  dat_i  : IN  STD_LOGIC_VECTOR( WIDTH-1 DOWNTO 0 );
  dat_o  : OUT STD_LOGIC );
END wide_nor_gate;

ARCHITECTURE wide_nor_gate_arch OF wide_nor_gate IS

BEGIN
  
  nor_gate : PROCESS( dat_i )
    VARIABLE result : STD_LOGIC;
  BEGIN
    result := '0';
    FOR i IN 0 TO WIDTH-1
    LOOP
      result := result or dat_i(i);
    END LOOP; 
    dat_o <= not result;
  END PROCESS;
 
END wide_nor_gate_arch;


