----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 27.09.2017 09:13:01
-- Design Name: 
-- Module Name: output_port - output_port_arch
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity output_port is
    Port ( clk : in STD_LOGIC;
           clr : in STD_LOGIC;
           addr : in STD_LOGIC_VECTOR (7 downto 0);
           din : in STD_LOGIC_VECTOR (15 downto 0);
           output : out STD_LOGIC_VECTOR (15 downto 0);
           rw : in STD_LOGIC);
end output_port;

architecture output_port_arch of output_port is

SIGNAL en : STD_LOGIC;

begin

  ENABLE: PROCESS( addr )
  BEGIN
    IF addr(7 downto 1) = "1111111"
    THEN
      en <= '1';
    ELSE
      en <= '0';
    END IF;  
  END PROCESS;

  REG_LOW: PROCESS(clk, clr, en, addr)
  BEGIN
    IF clr='1'
    THEN
      output(7 downto 0) <= (OTHERS=>'0');
    ELSIF clk='1' and clk'event
    THEN
      IF en='1' and addr(0)='0'
      THEN
        output(7 downto 0) <= din(7 downto 0);
      END IF;
    END IF;
  END PROCESS;
  
  REG_HIGH: PROCESS(clk, clr, en, addr)
  BEGIN
    IF clr='1'
    THEN
      output(15 downto 8) <= (OTHERS=>'0');
    ELSIF clk='1' and clk'event
    THEN
      IF en='1' and addr(0)='1'
      THEN
        output(15 downto 8) <= din(7 downto 0);
      END IF;
    END IF;
  END PROCESS;

end output_port_arch;
